﻿Moves = {
	moveIdOffset = 2,
	moveIdOffsetDungeon = 4,
	moveIdOffsetGround = 2,
	ginsengOffset = 4,
	ginsengOffsetDungeon = 7,
	ginsengOffsetGround = 4,
	tableSize = 6,
	tableSizeDungeon = 8,
	tableSizeGround = 6,

}


function Moves.GetDungeonMoves(movesAddr)
	Moves.moveIdOffset = Moves.moveIdOffsetDungeon
	Moves.ginsengOffset = Moves.ginsengOffsetDungeon
	Moves.tableSize = Moves.tableSizeDungeon
	return Moves.GetMoves(movesAddr)
end

function Moves.GetGroundMoves(movesAddr)
	Moves.moveIdOffset = Moves.moveIdOffsetGround
	Moves.ginsengOffset = Moves.ginsengOffsetGround
	Moves.tableSize = Moves.tableSizeGround
	return Moves.GetMoves(movesAddr)
end

function Moves.GetMoves(movesAddr)
	local move1 = Moves.GetMove(movesAddr)
	local move2 = Moves.GetMove(movesAddr + Moves.tableSize)
	local move3 = Moves.GetMove(movesAddr + Moves.tableSize * 2)
	local move4 = Moves.GetMove(movesAddr + Moves.tableSize * 3)

	return {
		move1ID = move1.moveID,
		move2ID = move2.moveID,
		move3ID = move3.moveID,
		move4ID = move4.moveID,
		move1 = move1.moveName,
		move2 = move2.moveName,
		move3 = move3.moveName,
		move4 = move4.moveName,
	}
end

function Moves.GetMove(addr)
	local checkMark = 0x2713
	local infinityUni = 8734
	local xMark = 0x00D7
	local moveID = memory.read_u16_le(addr + Moves.moveIdOffset)
	local moveBf = Moves.MoveBitField(addr)
	local ginseng = memory.read_u8(addr + Moves.ginsengOffset)
	local move = " "
	--console.log(addr)
	--console.log(moveBf)
	-- 0x4: Ginseng boost GM
	--0x7: Ginseng boost DM
	--Moves.ginsengOffset
	if Moves.MASTER_LIST[moveID] ~= nil then
		move = Moves.MASTER_LIST[moveID].name
		if ginseng and ginseng > 0 then
			move = move .. "+" .. ginseng
		end
		if moveBf.aiEnabled == 1 and moveBf.set ~= 1 and moveBf.disabled ~= 1 then
			move = move .. utf8.char(checkMark)
		end
		if moveBf.set == 1 then
			move = utf8.char(checkMark) .. move
		end
		if moveBf.subLinkInChain == 1 then
			move = utf8.char(infinityUni) .. move
		end
		if moveBf.disabled == 1 then
			move = utf8.char(xMark) .. move
		end
	else
		move = " "
	end
	return {
		moveName = move,
		moveID = moveID,
	}
end

function Moves.MoveBitField(addr)
	local byte0 = memory.read_u8(addr)
	local bfm = Program.BitFieldMap(byte0)
	return {
		exists = bfm.bin0,
		subLinkInChain = bfm.bin1,
		aiEnabled = bfm.bin2,
		set = bfm.bin3,
		disabled = bfm.bin5,
	}
end

Moves.MASTER_LIST = {
	[100] = { name = "Sky Attack" },
	[101] = { name = "Powder Snow" },
	[102] = { name = "Follow Me" },
	[103] = { name = "Meteor Mash" },
	[104] = { name = "Endure" },
	[105] = { name = "Rollout" },
	[106] = { name = "Scary Face" },
	[107] = { name = "Psybeam" },
	[108] = { name = "Psywave" },
	[109] = { name = "Psychic" },
	[10] = { name = "Sweet Scent" },
	[110] = { name = "Psycho Boost" },
	[111] = { name = "Hypnosis" },
	[112] = { name = "Uproar" },
	[113] = { name = "Water Spout" },
	[114] = { name = "Signal Beam" },
	[115] = { name = "Psych Up" },
	[116] = { name = "Submission" },
	[117] = { name = "Recover" },
	[118] = { name = "Earthquake" },
	[119] = { name = "Nature Power" },
	[11] = { name = "Charm" },
	[120] = { name = "Lick" },
	[121] = { name = "Flail" },
	[122] = { name = "Tail Whip" },
	[123] = { name = "Selfdestruct" },
	[124] = { name = "Stun Spore" },
	[125] = { name = "Bind" },
	[126] = { name = "Shadow Punch" },
	[127] = { name = "Shadow Ball" },
	[128] = { name = "Charge" },
	[129] = { name = "Thunderbolt" },
	[12] = { name = "Rain Dance" },
	[130] = { name = "Mist" },
	[131] = { name = "Fissure" },
	[132] = { name = "ExtremeSpeed" },
	[133] = { name = "Extrasensory" },
	[134] = { name = "Safeguard" },
	[135] = { name = "Absorb" },
	[136] = { name = "Sky Uppercut" },
	[137] = { name = "Skill Swap" },
	[138] = { name = "Sketch" },
	[139] = { name = "Headbutt" },
	[13] = { name = "Confuse Ray" },
	[140] = { name = "Double-Edge" },
	[141] = { name = "Sandstorm" },
	[142] = { name = "Sand-Attack" },
	[143] = { name = "Sand Tomb" },
	[144] = { name = "Spark" },
	[145] = { name = "Swift" },
	[146] = { name = "Kinesis" },
	[147] = { name = "Smog" },
	[148] = { name = "Growth" },
	[149] = { name = "Sacred Fire" },
	[14] = { name = "Hail" },
	[150] = { name = "Sheer Cold" },
	[151] = { name = "SolarBeam" },
	[152] = { name = "SonicBoom" },
	[153] = { name = "Fly" },
	[154] = { name = "Tackle" },
	[155] = { name = "Explosion" },
	[156] = { name = "Dive" },
	[157] = { name = "Fire Blast" },
	[158] = { name = "Waterfall" },
	[159] = { name = "Muddy Water" },
	[15] = { name = "Aromatherapy" },
	[160] = { name = "Stockpile" },
	[161] = { name = "Slam" },
	[162] = { name = "Twister" },
	[163] = { name = "Bullet Seed" },
	[164] = { name = "Twineedle" },
	[165] = { name = "Softboiled" },
	[166] = { name = "Egg Bomb" },
	[167] = { name = "Faint Attack" },
	[168] = { name = "Barrage" },
	[169] = { name = "Minimize" },
	[16] = { name = "Bubble" },
	[170] = { name = "Seismic Toss" },
	[171] = { name = "Supersonic" },
	[172] = { name = "Taunt" },
	[173] = { name = "Moonlight" },
	[174] = { name = "Peck" },
	[175] = { name = "Arm Thrust" },
	[176] = { name = "Horn Attack" },
	[177] = { name = "Horn Drill" },
	[178] = { name = "Wing Attack" },
	[179] = { name = "Aerial Ace" },
	[17] = { name = "Encore" },
	[180] = { name = "Icicle Spear" },
	[181] = { name = "Swords Dance" },
	[182] = { name = "Vine Whip" },
	[183] = { name = "Conversion" },
	[184] = { name = "Conversion 2" },
	[185] = { name = "Helping Hand" },
	[186] = { name = "Iron Defense" },
	[187] = { name = "Teleport" },
	[188] = { name = "ThunderShock" },
	[189] = { name = "Shock Wave" },
	[18] = { name = "Cut" },
	[190] = { name = "Quick Attack" },
	[191] = { name = "Sweet Kiss" },
	[192] = { name = "Thunder Wave" },
	[193] = { name = "Zap Cannon" },
	[194] = { name = "Block" },
	[195] = { name = "Howl" },
	[196] = { name = "Poison Gas" },
	[197] = { name = "Toxic" },
	[198] = { name = "Poison Fang" },
	[199] = { name = "PoisonPowder" },
	[19] = { name = "Rage" },
	[1] = { name = "Iron Tail" },
	[200] = { name = "Poison Sting" },
	[201] = { name = "Spike Cannon" },
	[202] = { name = "Acid Armor" },
	[203] = { name = "Take Down" },
	[204] = { name = "Jump Kick" },
	[205] = { name = "Bounce" },
	[206] = { name = "Hi Jump Kick" },
	[207] = { name = "Tri Attack" },
	[208] = { name = "Dragon Claw" },
	[209] = { name = "Trick" },
	[20] = { name = "Super Fang" },
	[210] = { name = "Triple Kick" },
	[211] = { name = "Drill Peck" },
	[212] = { name = "Mud Sport" },
	[213] = { name = "Mud-Slap" },
	[214] = { name = "Thief" },
	[215] = { name = "Amnesia" },
	[216] = { name = "Night Shade" },
	[217] = { name = "Growl" },
	[218] = { name = "Slack Off" },
	[219] = { name = "Surf" },
	[21] = { name = "Pain Split" },
	[220] = { name = "Role Play" },
	[221] = { name = "Needle Arm" },
	[222] = { name = "Double Kick" },
	[223] = { name = "Sunny Day" },
	[224] = { name = "Leer" },
	[225] = { name = "Wish" },
	[226] = { name = "Fake Out" },
	[227] = { name = "Sleep Talk" },
	[228] = { name = "Pay Day" },
	[229] = { name = "Assist" },
	[22] = { name = "Torment" },
	[230] = { name = "Heat Wave" },
	[231] = { name = "Sleep Powder" },
	[232] = { name = "Rest" },
	[233] = { name = "Ingrain" },
	[234] = { name = "Confusion" },
	[235] = { name = "Body Slam" },
	[236] = { name = "Swallow" },
	[237] = { name = "Curse" },
	[238] = { name = "Frenzy Plant" },
	[239] = { name = "Hydro Cannon" },
	[23] = { name = "String Shot" },
	[240] = { name = "Hydro Pump" },
	[241] = { name = "Hyper Voice" },
	[242] = { name = "Hyper Beam" },
	[243] = { name = "Superpower" },
	[244] = { name = "Steel Wing" },
	[245] = { name = "Spit Up" },
	[246] = { name = "DynamicPunch" },
	[247] = { name = "Guillotine" },
	[248] = { name = "ViceGrip" },
	[249] = { name = "Knock Off" },
	[24] = { name = "Swagger" },
	[250] = { name = "Pound" },
	[251] = { name = "Razor Leaf" },
	[252] = { name = "Baton Pass" },
	[253] = { name = "Petal Dance" },
	[254] = { name = "Splash" },
	[255] = { name = "BubbleBeam" },
	[256] = { name = "Doom Desire" },
	[257] = { name = "Belly Drum" },
	[258] = { name = "Barrier" },
	[259] = { name = "Light Screen" },
	[25] = { name = "Snore" },
	[260] = { name = "Scratch" },
	[261] = { name = "Hyper Fang" },
	[262] = { name = "Ember" },
	[263] = { name = "Secret Power" },
	[264] = { name = "Dizzy Punch" },
	[265] = { name = "Bulk Up" },
	[266] = { name = "Imprison" },
	[267] = { name = "FeatherDance" },
	[268] = { name = "Whirlwind" },
	[269] = { name = "Beat Up" },
	[26] = { name = "Heal Bell" },
	[270] = { name = "Blizzard" },
	[271] = { name = "Stomp" },
	[272] = { name = "Blast Burn" },
	[273] = { name = "Flash" },
	[274] = { name = "Teeter Dance" },
	[275] = { name = "Crush Claw" },
	[276] = { name = "Blaze Kick" },
	[277] = { name = "Present" },
	[278] = { name = "Eruption" },
	[279] = { name = "Sludge" },
	[27] = { name = "Screech" },
	[280] = { name = "Sludge Bomb" },
	[281] = { name = "Glare" },
	[282] = { name = "Transform" },
	[283] = { name = "Poison Tail" },
	[284] = { name = "Roar" },
	[285] = { name = "Bone Rush" },
	[286] = { name = "Camouflage" },
	[287] = { name = "Covet" },
	[288] = { name = "Tail Glow" },
	[289] = { name = "Bone Club" },
	[28] = { name = "Rock Throw" },
	[290] = { name = "Bonemerang" },
	[291] = { name = "Fire Spin" },
	[292] = { name = "Fire Punch" },
	[293] = { name = "Perish Song" },
	[294] = { name = "Wrap" },
	[295] = { name = "Spikes" },
	[296] = { name = "Magnitude" },
	[297] = { name = "Magical Leaf" },
	[298] = { name = "Magic Coat" },
	[299] = { name = "Mud Shot" },
	[29] = { name = "Rock Smash" },
	[2] = { name = "Ice Ball" },
	[300] = { name = "Mach Punch" },
	[301] = { name = "Protect" },
	[302] = { name = "Defense Curl" },
	[303] = { name = "Rolling Kick" },
	[304] = { name = "Substitute" },
	[305] = { name = "Detect" },
	[306] = { name = "Pin Missile" },
	[307] = { name = "Water Sport" },
	[308] = { name = "Water Gun" },
	[309] = { name = "Mist Ball" },
	[30] = { name = "Rock Slide" },
	[310] = { name = "Water Pulse" },
	[311] = { name = "Fury Attack" },
	[312] = { name = "Fury Swipes" },
	[313] = { name = "Destiny Bond" },
	[314] = { name = "False Swipe" },
	[315] = { name = "Foresight" },
	[316] = { name = "Mirror Coat" },
	[317] = { name = "Future Sight" },
	[318] = { name = "Milk Drink" },
	[319] = { name = "Calm Mind" },
	[31] = { name = "Weather Ball" },
	[320] = { name = "Mega Drain" },
	[321] = { name = "Mega Kick" },
	[322] = { name = "Mega Punch" },
	[323] = { name = "Megahorn" },
	[324] = { name = "Hidden Power" },
	[325] = { name = "Metal Claw" },
	[326] = { name = "Attract" },
	[327] = { name = "Mimic" },
	[328] = { name = "Frustration" },
	[329] = { name = "Leech Seed" },
	[32] = { name = "Whirlpool" },
	[330] = { name = "Metronome" },
	[331] = { name = "Dream Eater" },
	[332] = { name = "Acid" },
	[333] = { name = "Meditate" },
	[334] = { name = "Snatch" },
	[335] = { name = "Luster Purge" },
	[336] = { name = "Leaf Blade" },
	[337] = { name = "Recycle" },
	[338] = { name = "Reflect" },
	[339] = { name = "Refresh" },
	[33] = { name = "Fake Tears" },
	[340] = { name = "Revenge" },
	[341] = { name = "Dragon Rage" },
	[342] = { name = "DragonBreath" },
	[343] = { name = "Dragon Dance" },
	[344] = { name = "Ice Punch" },
	[345] = { name = "Ice Beam" },
	[346] = { name = "Fury Cutter" },
	[347] = { name = "Comet Punch" },
	[348] = { name = "Skull Bash" },
	[349] = { name = "Lock-On" },
	[34] = { name = "Sing" },
	[350] = { name = "Rock Blast" },
	[351] = { name = "Cotton Spore" },
	[352] = { name = "Struggle" },
	[353] = { name = "Aeroblast" },
	[354] = { name = "Volt Tackle" },
	[355] = { name = "regular attack" },
	[35] = { name = "Spite" },
	[360] = { name = "Wide Slash" },
	[36] = { name = "Air Cutter" },
	[37] = { name = "SmokeScreen" },
	[38] = { name = "Pursuit" },
	[394] = { name = "Vacuum-Cut" },
	[39] = { name = "DoubleSlap" },
	[3] = { name = "Yawn" },
	[40] = { name = "Mirror Move" },
	[41] = { name = "Overheat" },
	[42] = { name = "Aurora Beam" },
	[430] = { name = "Hammer Arm" },
	[431] = { name = "Iron Head" },
	[432] = { name = "Aqua Jet" },
	[433] = { name = "Aqua Tail" },
	[434] = { name = "Aqua Ring" },
	[435] = { name = "Spacial Rend" },
	[436] = { name = "Dark Pulse" },
	[437] = { name = "Ominous Wind" },
	[438] = { name = "Gastro Acid" },
	[439] = { name = "Healing Wish" },
	[43] = { name = "Memento" },
	[440] = { name = "Close Combat" },
	[441] = { name = "Wood Hammer" },
	[442] = { name = "Air Slash" },
	[443] = { name = "Energy Ball" },
	[444] = { name = "Tailwind" },
	[445] = { name = "Punishment" },
	[446] = { name = "Chatter" },
	[447] = { name = "Lucky Chant" },
	[448] = { name = "Guard Swap" },
	[449] = { name = "Heal Order" },
	[44] = { name = "Octazooka" },
	[450] = { name = "Heal Block" },
	[451] = { name = "Shadow Sneak" },
	[452] = { name = "Thunder Fang" },
	[453] = { name = "Rock Wrecker" },
	[454] = { name = "Focus Blast" },
	[455] = { name = "Giga Impact" },
	[456] = { name = "Defog" },
	[457] = { name = "Trump Card" },
	[458] = { name = "Grass Knot" },
	[459] = { name = "Cross Poison" },
	[45] = { name = "Flatter" },
	[460] = { name = "Attack Order" },
	[461] = { name = "Ice Fang" },
	[462] = { name = "Ice Shard" },
	[463] = { name = "Psycho Cut" },
	[464] = { name = "Psycho Shift" },
	[465] = { name = "Me First" },
	[466] = { name = "Embargo" },
	[467] = { name = "$$$ (Judgment)" },
	[468] = { name = "Seed Flare" },
	[469] = { name = "Brine" },
	[46] = { name = "Astonish" },
	[470] = { name = "X-Scissor" },
	[471] = { name = "Natural Gift" },
	[472] = { name = "Payback" },
	[473] = { name = "Zen Headbutt" },
	[474] = { name = "Wring Out" },
	[475] = { name = "Gyro Ball" },
	[476] = { name = "Shadow Claw" },
	[477] = { name = "Shadow Force" },
	[478] = { name = "Gravity" },
	[479] = { name = "Vacuum Wave" },
	[47] = { name = "Will-O-Wisp" },
	[480] = { name = "Stealth Rock" },
	[481] = { name = "Stone Edge" },
	[482] = { name = "Switcheroo" },
	[483] = { name = "Dark Void" },
	[484] = { name = "Earth Power" },
	[485] = { name = "Gunk Shot" },
	[486] = { name = "Seed Bomb" },
	[487] = { name = "Double Hit" },
	[488] = { name = "Assurance" },
	[489] = { name = "Charge Beam" },
	[48] = { name = "Return" },
	[490] = { name = "Pluck" },
	[491] = { name = "Night Slash" },
	[492] = { name = "Acupressure" },
	[493] = { name = "Magnet Rise" },
	[494] = { name = "Roar of Time" },
	[495] = { name = "Poison Jab" },
	[496] = { name = "Toxic Spikes" },
	[497] = { name = "Last Resort" },
	[498] = { name = "Dragon Rush" },
	[499] = { name = "Trick Room" },
	[49] = { name = "Grudge" },
	[4] = { name = "Lovely Kiss" },
	[500] = { name = "Drain Punch" },
	[501] = { name = "Mud Bomb" },
	[502] = { name = "U-turn" },
	[503] = { name = "Fling" },
	[504] = { name = "Worry Seed" },
	[505] = { name = "Crush Grip" },
	[506] = { name = "Heart Swap" },
	[507] = { name = "Force Palm" },
	[508] = { name = "Aura Sphere" },
	[509] = { name = "Roost" },
	[50] = { name = "Strength" },
	[510] = { name = "Bullet Punch" },
	[511] = { name = "Power Whip" },
	[512] = { name = "Power Gem" },
	[513] = { name = "Power Swap" },
	[514] = { name = "Power Trick" },
	[515] = { name = "Sucker Punch" },
	[516] = { name = "Feint" },
	[517] = { name = "Flare Blitz" },
	[518] = { name = "Brave Bird" },
	[519] = { name = "Lava Plume" },
	[51] = { name = "Counter" },
	[520] = { name = "Defend Order" },
	[521] = { name = "Discharge" },
	[522] = { name = "Fire Fang" },
	[523] = { name = "Magnet Bomb" },
	[524] = { name = "Magma Storm" },
	[525] = { name = "Copycat" },
	[526] = { name = "Lunar Dance" },
	[527] = { name = "Mirror Shot" },
	[528] = { name = "Miracle Eye" },
	[529] = { name = "Bug Bite" },
	[52] = { name = "Flame Wheel" },
	[530] = { name = "Bug Buzz" },
	[531] = { name = "Wake-Up Slap" },
	[532] = { name = "Metal Burst" },
	[533] = { name = "Head Smash" },
	[534] = { name = "Captivate" },
	[535] = { name = "Avalanche" },
	[536] = { name = "Flash Cannon" },
	[537] = { name = "Leaf Storm" },
	[538] = { name = "Draco Meteor" },
	[539] = { name = "Dragon Pulse" },
	[53] = { name = "Flamethrower" },
	[540] = { name = "Rock Polish" },
	[541] = { name = "Rock Climb" },
	[542] = { name = "Nasty Plot" },
	[54] = { name = "Odor Sleuth" },
	[55] = { name = "Sharpen" },
	[56] = { name = "Double Team" },
	[57] = { name = "Gust" },
	[58] = { name = "Harden" },
	[59] = { name = "Disable" },
	[5] = { name = "Nightmare" },
	[60] = { name = "Razor Wind" },
	[61] = { name = "Bide" },
	[62] = { name = "Crunch" },
	[63] = { name = "Bite" },
	[64] = { name = "Thunder" },
	[65] = { name = "ThunderPunch" },
	[66] = { name = "Endeavor" },
	[67] = { name = "Facade" },
	[68] = { name = "Karate Chop" },
	[69] = { name = "Clamp" },
	[6] = { name = "Morning Sun" },
	[70] = { name = "Withdraw" },
	[71] = { name = "Constrict" },
	[72] = { name = "Brick Break" },
	[73] = { name = "Rock Tomb" },
	[74] = { name = "Focus Energy" },
	[75] = { name = "Focus Punch" },
	[76] = { name = "Giga Drain" },
	[77] = { name = "Reversal" },
	[78] = { name = "SmellingSalt" },
	[79] = { name = "Spore" },
	[7] = { name = "Vital Throw" },
	[80] = { name = "Leech Life" },
	[81] = { name = "Slash" },
	[82] = { name = "Silver Wind" },
	[83] = { name = "Metal Sound" },
	[84] = { name = "GrassWhistle" },
	[85] = { name = "Tickle" },
	[86] = { name = "Spider Web" },
	[87] = { name = "Crabhammer" },
	[88] = { name = "Haze" },
	[89] = { name = "Mean Look" },
	[8] = { name = "Dig" },
	[90] = { name = "Cross Chop" },
	[91] = { name = "Outrage" },
	[92] = { name = "Low Kick" },
	[93] = { name = "AncientPower" },
	[94] = { name = "Synthesis" },
	[95] = { name = "Agility" },
	[96] = { name = "Rapid Spin" },
	[97] = { name = "Icy Wind" },
	[98] = { name = "Mind Reader" },
	[99] = { name = "Cosmic Power" },
	[9] = { name = "Thrash" },

}
